﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BaileyFarmerGame
{
    class Farmer
    {
        private ArrayList northBank = new ArrayList();
        private ArrayList southBank = new ArrayList();
        private Direction farmer;

        public Farmer()
        {
            northBank.Add("FOX");
            northBank.Add("CHICKEN");
            northBank.Add("GRAIN");

            southBank.Clear();

            farmer = Direction.North;
        }

        public enum Direction
        {
            North,
            South
        }

        public ArrayList NorthBank
        {
            get
            {
                return northBank;
            }
        }

        public ArrayList SouthBank
        {
            get
            {
                return southBank;
            }
        }

        public Direction TheFarmer
        {
            get
            {
                return farmer;
            }
        }

        public string Move(string item)
        {
            string result = "NO ERROR";
            string items = item;

            switch (items)
            {
                case "CHICKEN":
                    if (farmer == Direction.North && northBank.Contains("CHICKEN"))
                    {
                        northBank.Remove("CHICKEN");
                        southBank.Add("CHICKEN");
                        farmer = Direction.South;
                    }
                    else if (farmer != Direction.South || !southBank.Contains("CHICKEN"))
                    {
                        result = "ERROR";
                    }
                    else
                    {
                        southBank.Remove("CHICKEN");
                        northBank.Add("CHICKEN");
                        farmer = Direction.North;
                    }
                    return result;
                case "FOX":
                    if (farmer == Direction.North && northBank.Contains("FOX"))
                    {
                        northBank.Remove("FOX");
                        southBank.Add("FOX");
                        farmer = Direction.South;
                    }
                    else if (farmer != Direction.South || !southBank.Contains("FOX"))
                    {
                        result = "ERROR";
                    }
                    else
                    {
                        southBank.Remove("FOX");
                        northBank.Add("FOX");
                        farmer = Direction.North;
                    }
                    return result;
                case "":  
                    if (items == null || items.Length != 0)
                    {
                        result = "ERROR";
                    }
                    else if (farmer != Direction.North)
                    {
                        farmer = Direction.North;
                    }
                    else
                    {
                        farmer = Direction.South;
                    }
                    return result;
                default:
                    if (farmer == Direction.North && northBank.Contains("GRAIN"))
                    {
                        northBank.Remove("GRAIN");
                        southBank.Add("GRAIN");
                        farmer = Direction.South;
                    }
                    else if (farmer != Direction.South || southBank.Contains("GRAIN"))
                    {
                        southBank.Remove("GRAIN");
                        northBank.Add("GRAIN");
                        farmer = Direction.North;
                    }
                    return result;
            }
        }

        public string AnimalAteFood()
        {
            string eat = "NOT EATEN ";

            if (farmer != Direction.North)
            {
                if (farmer == Direction.South)
                {
                    if (northBank.Contains("CHICKEN") && northBank.Contains("GRAIN"))
                    {
                        eat = "ATEGRAIN";
                    }
                    else if (northBank.Contains("CHICKEN") && northBank.Contains("FOX"))
                    {
                        eat = "ATECHICKEN";
                    }
                }
            }
            else if (southBank.Contains("CHICKEN") && southBank.Contains("GRAIN"))
            {
                eat = "ATEGRAIN";
            }
            else if (southBank.Contains("CHICKEN") && southBank.Contains("FOX"))
            {
                eat = "ATECHICKEN";
            }

            return eat;
        }

        public bool DetermineWin()
        {
            bool results = false;

            if (southBank.Contains("CHICKEN") && southBank.Contains("GRAIN") && southBank.Contains("FOX"))
            {
                results = true;
            }

            return results;
        }

    }
}